Type Shader
Field mesh
Field index
Field vu#[20000]
Field vv#[20000]
Field alg,a#,b#,c#,d#,e#,f#,g#,n#
End Type

Function AddShader(mesh) 
Sh.Shader=New Shader
Sh\mesh=mesh
NameEntity(Sh\mesh,Handle(Sh))
For s=1 To CountSurfaces(mesh)
surf=GetSurface(mesh,s)
Sh\index=CountVertices(surf)-1
For v=0 To CountVertices(surf)-1
Sh\vu#[v]=VertexU#(surf,v) 
Sh\vv#[v]=VertexV#(surf,v)
Sh\alg=0
Next
Next 
End Function 

Function UpdateShaders()
Local surf
For Sh.Shader=Each Shader

If Sh\alg=1
For s=1 To CountSurfaces(Sh\mesh)
surf=GetSurface(Sh\mesh,s)
For i=0 To Sh\index-1

VertexTexCoords surf,i,Sh\vu#[i]+Rnd(-Sh\n#,Sh\n#),Sh\vv#[i]+Rnd(-Sh\n#,Sh\n#)
Next
Next 
EndIf 

If Sh\alg=2
For s=1 To CountSurfaces(Sh\mesh)
surf=GetSurface(Sh\mesh,s)
For i=0 To Sh\index-1
Sh\a#=MilliSecs()/Sh\b#
Sh\c#=Sin(Sh\a#+Sh\vu#[i]*Sh\f#)*Sh\d#
VertexTexCoords surf,i,Sh\vu#[i]+Sh\c#+Rnd(-Sh\n#,Sh\n#),Sh\vv#[i]+Sh\c#+Rnd(-Sh\n#,Sh\n#)
VertexCoords surf,i,vertexx(surf,i)+Sh\c#,vertexy(surf,i)+Sh\c#,vertexz(surf,i)+Sh\c#

Next
Next 
EndIf

If Sh\alg=3
For s=1 To CountSurfaces(Sh\mesh)
surf=GetSurface(Sh\mesh,s)
For i=0 To Sh\index-1
Sh\a#=MilliSecs()/Sh\b#
Sh\e#=Cos(Sh\a#+Sh\vv#[i]*Sh\f#)*Sh\d#
VertexTexCoords surf,i,Sh\vu#[i]+Sh\e#+Rnd(-Sh\n#,Sh\n#),Sh\vv#[i]+Sh\e#+Rnd(-Sh\n#,Sh\n#)
VertexCoords surf,i,vertexx(surf,i)+Sh\e#,vertexy(surf,i)+Sh\e#,vertexz(surf,i)+Sh\e#
Next
Next 
EndIf

If Sh\alg=4
For s=1 To CountSurfaces(Sh\mesh)
surf=GetSurface(Sh\mesh,s)
For i=0 To Sh\index-1
Sh\a#=MilliSecs()/Sh\b#
Sh\c#=Sin(Sh\a#+Sh\vu#[i]*Sh\f#)*Sh\d#
Sh\e#=Cos(Sh\a#+Sh\vv#[i]*Sh\f#)*Sh\d#
VertexTexCoords surf,i,Sh\vu#[i]+Sh\c#+Rnd(-Sh\n#,Sh\n#),Sh\vv#[i]+Sh\e#+Rnd(-Sh\n#,Sh\n#)
VertexCoords surf,i,vertexx(surf,i)+Sh\e#,vertexy(surf,i)+Sh\e#,vertexz(surf,i)+Sh\e#
Next
Next 
EndIf

If Sh\alg=5
For s=1 To CountSurfaces(Sh\mesh)
surf=GetSurface(Sh\mesh,s)
For i=0 To Sh\index-1
Sh\a#=MilliSecs()/Sh\b#
Sh\c#=Sin(Sh\a#+(Sh\vu#[i]+Sh\vv#[i])*Sh\f#)*Sh\d#
Sh\e#=Cos(Sh\a#+(Sh\vv#[i]+Sh\vu#[i])*Sh\g#)*Sh\d#
VertexTexCoords surf,i,Sh\vu#[i]+Sh\c#+Rnd(-Sh\n#,Sh\n#),Sh\vv#[i]+Sh\e#+Rnd(-Sh\n#,Sh\n#)
VertexCoords surf,i,vertexx(surf,i)+Sh\e#,vertexy(surf,i)+Sh\e#,vertexz(surf,i)+Sh\e#
Next
Next 
EndIf

Next 
End Function 

Function ChangeAlg(mesh,alg)
Sh.Shader = Object.Shader(EntityName(mesh))
Sh\alg=alg   
End Function 

Function ChangeA(mesh,a#)
Sh.Shader = Object.Shader(EntityName(mesh))
Sh\a#=a#   
End Function 

Function ChangeB(mesh,b#)
Sh.Shader = Object.Shader(EntityName(mesh))
Sh\b#=b#   
End Function 

Function ChangeC(mesh,c#)
Sh.Shader = Object.Shader(EntityName(mesh))
Sh\c#=c#   
End Function 

Function ChangeD(mesh,d#)
Sh.Shader = Object.Shader(EntityName(mesh))
Sh\d#=d#   
End Function

Function ChangeE(mesh,e#)
Sh.Shader = Object.Shader(EntityName(mesh))
Sh\e#=e#   
End Function  

Function ChangeF(mesh,f#)
Sh.Shader = Object.Shader(EntityName(mesh))
Sh\f#=f#   
End Function 

Function ChangeG(mesh,g#)
Sh.Shader = Object.Shader(EntityName(mesh))
Sh\g#=g#   
End Function 

Function ChangeN(mesh,n#)
Sh.Shader = Object.Shader(EntityName(mesh))
Sh\n#=n#   
End Function 

Function RemoveShader(mesh)
For Sh.Shader=Each Shader
For s=1 To CountSurfaces(Sh\mesh)
surf=GetSurface(Sh\mesh,s)
For i=0 To Sh\index-1
VertexTexCoords surf,i,Sh\vu#[i],Sh\vv#[i]
Next 
Next
Delete Sh
Next   
End Function 








 